#include "TESTE.INC"
#include "MACROS.INC"

ORG 0
	JMP INICIO


ORG 0x0b
	INC		R3
	CJNE	R3,#21,CAIFORA
	JB		F_DEZ_UNI,SHOWD	;SE FOR 1, SIGNIFICA QUE DEVER MOSTRAR A DEZENA, SE NO...
	MOV		P1,MINUTO		;MOSTRA O N
	SETB	F_DEZ_UNI		;DIGO QUE NA PROXIMA INT DEVER MOSTRAR A DEZENA...
	MOV		R3,#0
	JMP		CONTIN			;RETORNO DA INT
SHOWD:
	MOV		A,MINUTO		;MOVE PARTE ALTA DO MINUTO E...
	SWAP	A
	MOV		P1,A			;MOSTRA O N
	CLR		F_DEZ_UNI  		;DIGO QUE NA PROXIMA INT DEVER MOSTRAR A UNIDADE
	MOV		R3,#0
CONTIN:
	INC		R5
	CJNE	R5,#65,CAIFORA
	SETB	F_TIME_OUT
	MOV		R5,#0
	
CAIFORA:
	RETI

INICIO:
    MOV R0,#0
    MOV R1,#0
    MOV R2,#0
    MOV R3,#0
    MOV R4,#0
    MOV R5,#0
	MOV	R6,#0
    MOV p1,#0
	MOV	V_STATUS,#0
    Mov TCON,#12h
    MOV IE, #82h
    mov Tmod, #2
    mov th0, #4
    mov tl0, #4

	CLR		BUZZER						;DESATIVA BUZZER

ROTINA:
	JNB		F_TIME_OUT,ROTINA
	JB		SENSOR,ZERA_CONT

	INC		SEGUNDO
	CJNE	SEGUNDO,#61,NAO_APITA
	MOV		SEGUNDO,#0
	INC		MINUTO
	M_JE	MINUTO,#10,AJUSTA_NUM
AJ_B:
	CJNE	MINUTO,#21,NAO_APITA
	CLR		F_TIME_OUT
	JMP		ACIONA
NAO_APITA:
	CLR		F_BUZZER
RETURN:
	CLR		F_TIME_OUT
	JMP		ROTINA
AJUSTA_NUM:
	MOV		MINUTO,#16
	JMP		AJ_B

ACIONA:	
	SETB	BUZZER						;ACIONA O BUZZER
	CALL	R_TX10MS					
	CLR		BUZZER						;DESATIVA BUZZER
	CALL	R_TX10MS
	JNB		PUSH_B,ACIONA
ZERA_CONT:
	MOV		MINUTO,#0
	MOV		SEGUNDO,#0
	CLR		F_TIME_OUT
	JMP 	ROTINA
		

			
;-------------------------------------------------------------------------------------------------
;	DELAY VARIAVEL CONFORME ENTRADA EM FUNO DE 10MS
;	ENTRADA: ACC - QUE MULTIPLICA 10MS E GERA DELAY
;	AFETA: V_T10M,V_T100U
;-------------------------------------------------------------------------------------------------

R_TX10MS:
	MOV		V_XT,#5
T_X100:
	MOV		V_T10M,#255
T_X200:
	MOV		V_T100U,#255		;CARREGA K_CYCLE
T_X300:						;QUEIMA TEMPO (~3*CYCLE)
	DJNZ	V_T100U,T_X300
	DJNZ	V_T10M,T_X200
	DJNZ	V_XT,T_X100
	RET

END